# vim: set ts=4 sw=4 et:
# Copyright (c) 2006-2010 oc2pus
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments to packman@links2linux.de

%define _with_amr	1
%define soname		0

Name:           gpac
Summary:        A multimedia framework covering MPEG-4, VRML/X3D and SVG
Version:        0.4.5
Release:        1.pm.4.1
Source:         gpac-%{version}.tar.bz2
%if "%{_with_amr}" == "1"
Source1:        http://www.3gpp.org/ftp/Specs/archive/26_series/26.104/26104-610.zip
Source2:        http://www.3gpp.org/ftp/Specs/archive/26_series/26.204/26204-600.zip
%endif
Source90:       %{name}-rpmlintrc
Patch0:         %{name}-bufferoverflow.patch
Patch1:         %{name}-a52dec.patch
URL:            http://gpac.sourceforge.net/
License:        GNU Lesser General Public License version 2.1 or later (LGPLv2.1 or later)
Group:          Productivity/Multimedia/Video/Editors and Convertors
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
BuildRequires:  alsa-devel
BuildRequires:  dos2unix
BuildRequires:  doxygen
BuildRequires:  freetype2-devel
BuildRequires:  freeglut-devel
BuildRequires:  gamin-devel
BuildRequires:  gcc-c++
BuildRequires:  ImageMagick
BuildRequires:  liba52-devel
#BuildRequires:	libamrnb-devel
#BuildRequires:	libamrwb-devel
BuildRequires:  libfaad2-devel
BuildRequires:  libffmpeg_oldabi-devel
BuildRequires:  libjpeg-devel
BuildRequires:  libjs-devel libjs1
BuildRequires:  libmad-devel
BuildRequires:  libogg-devel
BuildRequires:  libopenjpeg-devel
BuildRequires:  libpng-devel
BuildRequires:  librsvg2-devel >= 2.5.0
BuildRequires:  libtheora-devel
BuildRequires:  libvorbis-devel
BuildRequires:  libxml2-devel
BuildRequires:  libxvidcore-devel
BuildRequires:  Mesa-devel
%if %suse_version <= 1110
BuildRequires:  mozilla-xulrunner190-devel
%endif
%if %suse_version > 1110 && %suse_version < 1140
BuildRequires:  mozilla-xulrunner191-devel
%endif
%if %suse_version >= 1140
BuildRequires:  mozilla-xulrunner192-devel
%endif
BuildRequires:  openssl-devel
BuildRequires:  SDL-devel
BuildRequires:  unzip
BuildRequires:  update-desktop-files
%if 0%{?suse_version} >= 1140
BuildRequires:  wxWidgets-wxcontainer-devel
%else
BuildRequires:  wxGTK-devel
%endif
BuildRequires:  zlib-devel

%description
GPAC is a multimedia framework for MPEG-4, VRML/X3D and SVG/SMIL.

GPAC is built upon an implementation of the MPEG-4 Systems standard
(ISO/IEC 14496-1) developed from scratch in C.

The main development goal is to provide a clean (a.k.a. readable by
as many people as possible), small and flexible alternative to the
MPEG-4 Systems reference software (known as IM1 and distributed in
ISO/IEC 14496-5).

The second development goal is to achieve integration of recent
multimedia standards (SVG/SMIL, VRML, X3D, SWF, etc) into a single
framework. This stage is still under drafting but GPAC already
supports most of VRML97, some X3D as well as very simple SVG.

GPAC already features 2D and 3D multimedia playback, MPEG-4 Systems
encoders/multiplexers and publishing tools for content distribution.

GPAC is licensed under the GNU Lesser General Public License.

The current GPAC release (0.4.5) already covers a very large part of
the MPEG-4 standard, and features what can probably be seen as the
most advanced and robust 2D MPEG-4 Player available worldwide, as
well as a decent 3D MPEG-4/VRML player.

Author:         Jean Le Feuvre <jeanlf at users.sourceforge.net>

%package -n libgpac%{soname}
Summary:        Shared libraries for gpac
Group:          System/Libraries

%description -n libgpac%{soname}
Shared libraries for package gpac.

%package -n libgpac-devel
Summary:        Development files for gpac
Group:          Development/Languages/C and C++
Requires:       libgpac%{soname} = %{version}
Requires:       freetype2-devel
Requires:       freeglut-devel
Requires:       ImageMagick
Requires:       liba52-devel
#Requires:	libamrnb-devel
#Requires:	libamrwb-devel
Requires:       libfaad2-devel
Requires:       libffmpeg_oldabi-devel
Requires:       libjpeg-devel
Requires:       libjs-devel libjs1
Requires:       libmad-devel
Requires:       libopenjpeg-devel
Requires:       libogg-devel
Requires:       libpng-devel
Requires:       libtheora-devel
Requires:       libvorbis-devel
Requires:       libxml2-devel
Requires:       libxvidcore-devel
Requires:       Mesa-devel
%if %suse_version <= 1110
Requires:       mozilla-xulrunner190-devel
%else
Requires:       mozilla-xulrunner191-devel
%endif
Requires:       openssl-devel
Requires:       SDL-devel
%if 0%{?suse_version} >= 1140
Requires:       wxWidgets-wxcontainer-devel
%else
Requires:       wxGTK-devel
%endif
Requires:       zlib-devel
# old name
Provides:       gpac-devel = 0.4.4
Obsoletes:      gpac-devel < 0.4.4

%description -n libgpac-devel
Development files for gpac.

Author:         Jean Le Feuvre <jeanlf@users.sourceforge.net>

%package -n Osmo4
Summary:        MPEG-4 Media player based on gpac
Group:          Productivity/Multimedia/Video/Players
Requires:       %{name} = %{version}

%description -n Osmo4
Osmo4 is an MPEG-4 player with the following features:
* MPEG-4 Systems player:
* Optimized 2D graphics renderer compliant with the Complete2D Scene
  Graph and Graphics profiles.
* Video and audio presentation achieved through plugins
* Multimedia player features:
* Timeline controls: play, pause, step.
* Graphics features: antialising, zoom and pan, scalable resizing
  of rendering area
* Support for Advanced Text and Graphics extension of MPEG-4 Systems
* Frame export to JPG, PNG, BMP.

Osmo4 enables the use of MPEG-4 Systems in a vast aplication domain,
among which:
* downloaded or streamed cartoons
* synchronized, interactive mixes of graphics, text, video and audio
* applications benefiting from MPEG-7 and MPEG-21 advances: meta-data,
  encryption, watermarking, rights management

%if %suse_version <= 1030
%package browser-plugin
Summary:        Osmozilla is a GPAC plugin for Mozilla-based browsers
Group:          Productivity/Networking/Web/Utilities
Requires:       %{name} = %{version}

%description browser-plugin
Osmozilla is a GPAC plugin for Mozilla-based browsers.
%endif

%prep
%setup -q -n %{name}
%patch0 -p1
%patch1 -p1

dos2unix     configure
%__chmod 755 configure
dos2unix     AUTHORS BUGS Changelog COPYING README TODO
%__chmod 644 AUTHORS BUGS Changelog COPYING README TODO
dos2unix     doc/CODING_STYLE doc/ipmpx_syntax.bt
%__chmod 644 doc/CODING_STYLE doc/ipmpx_syntax.bt

# 64bit adjustments ...
%__perl -p -i -e 's/lGLU/lGLU\ \-L\/usr\/X11R6\/%{_lib}/g' \
    configure
%__perl -p -i -e 's,\$prefix/lib/gpac,\$prefix/%{_lib}/gpac,' \
    configure
%__perl -p -i -e 's,\$\(prefix\)/lib,\$(prefix)/%{_lib},' \
    Makefile
%__perl -p -i -e 's/Wall/w/g' `find -name \
    Makefile`

# libpng-1.4.0 needs this
%__sed -i -e 's|png_infopp_NULL|NULL|g' \
    src/media_tools/img.c

# define SONAME number from the first number of gpac version
%__sed -i -e 's|EXTRALIBS+=$(GPAC_SH_FLAGS)|EXTRALIBS+=$(GPAC_SH_FLAGS)\nLDFLAGS+="-Wl,-soname,libgpac.so.%{soname}"|' \
    src/Makefile

# unpack amr files
%if "%{_with_amr}" == "1"
%__install -dm 755 modules/amr_float_dec/amr_nb_ft
pushd modules/amr_float_dec/amr_nb_ft
    %__unzip -q %{SOURCE1}
    %__unzip -qj 26104-610_ANSI_C_source_code.zip
popd

%__install -dm 755 modules/amr_float_dec/amr_wb_ft
pushd modules/amr_float_dec/amr_wb_ft
    %__unzip -q %{SOURCE2}
    %__unzip -qj 26204-600_ANSI-C_source_code.zip
popd
%endif

# new ffmpeg-API ...
%__sed -i -e 's|ffd->ctx->bits_per_sample|ffd->ctx->bits_per_coded_sample|g' \
    modules/ffmpeg_in/ffmpeg_decode.c
%__sed -i -e 's|CODEC_ID_MP3LAME|CODEC_ID_MP3|g' \
    modules/ffmpeg_in/ffmpeg_decode.c
%__sed -i -e 's|dec->bits_per_sample|dec->bits_per_coded_sample|g' \
    modules/ffmpeg_in/ffmpeg_demux.c
%__sed -i -e 's|avcodec_decode_audio|avcodec_decode_audio2|g' \
    modules/ffmpeg_in/ffmpeg_decode.c
%__sed -i -e 's|ffd->ctx->height->codec->height|ffd->ctx->height|g' \
    modules/ffmpeg_in/ffmpeg_decode.c

# use system openjpeg
%__sed -i -e 's|openjpeg.h|openjpeg/openjpeg.h|' \
    configure modules/img_in/jp2_dec.c

# Fix encoding warnings
%__cp -p Changelog Changelog.origine
iconv -f ISO-8859-1 -t UTF8 Changelog.origine > Changelog
touch -r Changelog.origine Changelog
%__rm -rf Changelog.origine

%__cp -p doc/ipmpx_syntax.bt doc/ipmpx_syntax.bt.origine
iconv -f ISO-8859-1 -t UTF8 doc/ipmpx_syntax.bt.origine > doc/ipmpx_syntax.bt
touch -r doc/ipmpx_syntax.bt.origine doc/ipmpx_syntax.bt
%__rm -rf doc/ipmpx_syntax.bt.origine

%build
# regenerate plugin interface from IDL (see applications/osmozilla/readme.txt)
pushd applications/osmozilla
    %__chmod 666 nsIOsmozilla.xpt_linux; %__rm nsIOsmozilla.xpt_linux
    %__chmod 666 nsIOsmozilla.h
    %__chmod 666 nsIOsmozilla.idl

    %define _IDL_DIR `pkg-config --variable=idldir libxul`
    %define _INC_DIR `pkg-config --variable=includedir libxul`
    %define _LIB_DIR `pkg-config --variable=libdir libxul`
    
    %{_LIB_DIR}/xpidl \
    	-m header \
    	-I%{_IDL_DIR} \
    	-I%{_INC_DIR}/xpcom/idl \
    	nsIOsmozilla.idl
    %{_LIB_DIR}/xpidl \
    	-m typelib \
    	-I%{_IDL_DIR} \
    	-I%{_INC_DIR}/xpcom/idl \
    	nsIOsmozilla.idl
    %{_LIB_DIR}/xpt_link \
    	nposmozilla.xpt nsIOsmozilla.xpt
    
    %__cp nsIOsmozilla.xpt nsIOsmozilla.xpt_linux
popd

# configure the beast
./configure \
    --prefix=%{_prefix} \
    --mandir=%{_mandir} \
    --X11-libs=/usr/X11R6/%{_lib} \
%if "%{_with_amr}" == "1"
    --enable-amr \
%endif
    --enable-oss-audio \
    --xulsdk-path=`pkg-config --variable=includedir libxul` \
    --mozdir=%{_libdir}/browser-plugins \
    --use-openjpeg=system \
    --use-ogg=system \
    --use-vorbis=system \
    --use-theora=system \
    --extra-cflags="%optflags -D_FILE_OFFSET_BITS=64 -D_LARGE_FILES -D_LARGEFILE_SOURCE=1 -I%{_includedir}/js -DXP_UNIX -fPIC"

# make the beast (NO parallel build possible ...)
%__make all
%__make sggen

%if %suse_version <= 1030
# mozilla-xulrunner191 has no npupp.h ...

# make browser-plugin
%__make -C applications/osmozilla \
    XUL_CFLAGS="`pkg-config --define-variable=includetype=unstable --cflags libxul` `pkg-config --cflags nspr`"
%endif

# create dev-docs
pushd doc
    doxygen -u
    doxygen
popd

%install
%__install -dm 755 %{buildroot}%{_bindir}

%makeinstall \
    INSTFLAGS=""
%__make install-lib \
    DESTDIR=%{buildroot}

%if %suse_version <= 1030
# browser-plugin
#%__make -C applications/osmozilla install \
#	XUL_CFLAGS="`pkg-config --cflags libxul nspr`"
%__install -dm 755 %{buildroot}%{_libdir}/browser-plugins
%__install -m 644 bin/gcc/nposmozilla.so \
    %{buildroot}%{_libdir}/browser-plugins
%__install -m 644 bin/gcc/nposmozilla.xpt \
    %{buildroot}%{_libdir}/browser-plugins
%endif

# install generated sggen binaries
for i in MPEG4 X3D; do
    %__install -m 755 applications/generators/$i/${i}Gen \
    	%{buildroot}%{_bindir}
done
%__install -m 755 bin/gcc/mp4* \
    %{buildroot}%{_bindir}

# create links for so-name
%__mv %{buildroot}%{_libdir}/libgpac-%{version}.so \
    %{buildroot}%{_libdir}/libgpac.so.%{version}
ln -sf libgpac.so.%{version} \
    %{buildroot}%{_libdir}/libgpac.so.0
ln -sf libgpac.so.0 \
    %{buildroot}%{_libdir}/libgpac.so

# icon
%__install -dm 755 %{buildroot}%{_datadir}/pixmaps
convert -size 48x48 applications/osmo4_wx/osmo4.xpm \
    Osmo4.png
%__install -m 644 Osmo4.png \
    %{buildroot}%{_datadir}/pixmaps

# menu-entry
%__install -dm 755 %{buildroot}%{_datadir}/applications
%__cat > Osmo4.desktop << EOF
[Desktop Entry]
Comment=MPEG-4 Media player based on gpac
Name=Osmo4
GenericName=MPEG-4 Media player based on gpac
Type=Application
Exec=Osmo4
Icon=Osmo4
#Encoding=UTF-8
Terminal=false
#Categories=AudioVideo;Player;
EOF
%suse_update_desktop_file -i Osmo4 AudioVideo Player

%__rm %{buildroot}%{_libdir}/*.a

%clean
%{?buildroot:%__rm -rf "%{buildroot}"}

%post -n libgpac%{soname} -p /sbin/ldconfig

%postun -n libgpac%{soname} -p /sbin/ldconfig

%files
%defattr(-,root,root)
%doc AUTHORS BUGS Changelog COPYING README TODO
%doc doc/configuration.html
%{_bindir}/MP4Box
%{_bindir}/MP4Client
%{_bindir}/MPEG4Gen
%{_bindir}/X3DGen
%{_bindir}/mp42ts
%{_bindir}/mp4_streamer
%dir %{_libdir}/%{name}
%{_libdir}/%{name}/*
%dir %{_datadir}/%{name}
%{_datadir}/%{name}/*
%{_mandir}/man1/*

%files -n libgpac%{soname}
%defattr(-,root,root)
%{_libdir}/*.so.%{soname}
%{_libdir}/*.so.%{soname}.*

%files -n libgpac-devel
%defattr(-,root,root)
%doc doc/CODING_STYLE doc/ipmpx_syntax.bt
%doc doc/html/*
%dir %{_includedir}/%{name}
%{_includedir}/%{name}/*
%{_libdir}/*.so

%files -n Osmo4
%defattr(-,root,root)
#%doc doc/osmo4*
%{_bindir}/Osmo4
%{_datadir}/pixmaps/Osmo4.png
%{_datadir}/applications/Osmo4.desktop

%if %suse_version <= 1030
%files browser-plugin
%defattr(-,root,root)
%{_libdir}/browser-plugins/nposmozilla.*
%endif

%changelog
* Mon Jan 11 2010 toni@links2linux.de
- fixed buildroot usage:
  Error: no modules found in /usr/src/packages/BUILDROOT/gpac-0.4.5-0.pm.5.17.x86_64/usr/lib64/gpac
* Tue Dec  2 2008 toni@links2linux.de
- update to 0.4.5
- added libgpac0 subpackage
- added librsvg2(-devel) to BuildRequires
- install also the *Gen applications
* Wed Sep 24 2008 toni@links2linux.de
- rebuild with new libffmpeg0-devel, libmad-devel, libfaad2-devel,
  libxvidcore-devel packages
- patched for new ffmpeg-API
  (bits_per_sample ==> bits_per_coded_sample, CODEC_ID_MP3LAME ==> CODEC_ID_MP3)
* Fri Dec 21 2007 toni@links2linux.de
- rebuild with new ffmpeg package
* Sun Jul  1 2007 toni@links2linux.de
- use --extra-flags, as CPFLAGS/OPTFLAGS are not recognized in configure
  thx to Richard Sotke <tee@teeforum.com>
* Fri Jun  1 2007 toni@links2linux.de
- merged in 64bit patch/spec-file and corrected BuildRequires
- added rebuild of idl
- should now build on all SuSE-10.x
* Thu May 31 2007 toni@links2linux.de
- update to 0.4.4
* Sat Apr 21 2007 toni@links2linux.de
- update to 0.4.3-cvs20070420
* Fri Mar  9 2007 toni@links2linux.de
- update to 0.4.3-cvs20070309
* Sun Jan 28 2007 toni@links2linux.de
- update to 0.4.3-cvs20070126
* Tue Jan 16 2007 toni@links2linux.de
- update to 0.4.3-cvs20070115
* Wed Dec 13 2006 toni@links2linux.de
- update to 0.4.3-cvs20061213
* Sat Dec  9 2006 toni@links2linux.de
- rebuild with browser-plugin and enabled --enable-amr
* Fri Dec  8 2006 toni@links2linux.de
- initial build 0.4.3-cvs20061114
